//************************************************************************
// Program Name	: Read ALL the numbers from and file and write 
//					the square of the value in a output.txt
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Read ALL the numbers from and file and write 
//					the square of the value in a output.txt
// Stack Frame:
//				|-----------------------|
//	  			|						|
//		sp'-->	|-----------------------|
//	  			|			&a			|
//				|-----------------------|<-- fp + 28
//	  			|						|
//				|-----------------------|<-- fp + 24
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|	 *** x30 = lr'	***	|
//				|-----------------------|
//	  			|	*** x30 = lr'	***	|
//				|-----------------------|<-- fp + 8
//	  			|		X29 = fp'		|
//				|-----------------------|
//	  			|		X29 = fp'		|
//sp=sp'-32 -->	|-----------------------| <-- fp
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//************************************************************************
//References:
//http://www.cplusplus.com/reference/cstdio/fopen/
//http://www.cplusplus.com/reference/cstdio/fscanf/
//http://www.cplusplus.com/reference/cstdio/fprintf/
//http://www.cplusplus.com/reference/cstdio/fclose/
//http://www.cplusplus.com/reference/cstdio/feof/
//************************************************************************

.data
FileOpenModeRead: 	.string	"r"
FileOpenModeWrite: 	.string	"w"
FileNameIn: 		.string	"test.txt"
FileNameOut: 		.string	"output.txt"
fscanf_str: 		.string	"%d"
fprintf_str: 		.string	"%d "

	.text
	.global	main

main:

	stp	x29, x30, [sp, -32]!
	add	x29, sp, 0

	// Open the File For reading
	adr	x1, FileOpenModeRead
	adr	x0, FileNameIn
	bl	fopen
	mov x20, x0			// Store the file pointer into X20
	// Open the File For Writting
	adr	x1, FileOpenModeWrite
	adr	x0, FileNameOut
	bl	fopen
	mov x21, x0			// Store the file pointer into X20

loop:
	add	x2, x29, 28		// The Location that fscanf will store the value
	adr	x1, fscanf_str
	mov	x0, x20			// The File pointer
	bl	fscanf
	
	ldr	w2, [x29, 28]	// Get the value from the stack
	mul w2, w2, w2		// Get the Square of the value
	
	adr	x1, fprintf_str
	mov	x0, x21			// The File pointer
	bl	fprintf
		
	mov	x0, x20			// The File pointer
	bl	feof			// feof will return !=0 on EndOfFile
	cbz w0, loop
	

	mov	x0, x20			// Get the File pointer
	bl	fclose			// Close the file.
	mov	x0, x21			// Get the File pointer
	bl	fclose			// Close the file.

	
	ldp	x29, x30, [sp], 32

	ret
