//************************************************************************
// Program Name	: Read a String from the input and then print it on the Screen
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Read a String from the input and then print it on the Screen
// Stack Frame:
//				|-----------------------|
//	  			|						|
//		sp'-->	|-----------------------|
//	  			|						|
//	  			|	...256 Bytes...		|
//	  			|						|
//				|-----------------------|<-- fp + 16
//	  			|	 *** x30 = lr'	***	|
//				|-----------------------|
//	  			|	*** x30 = lr'	***	|
//				|-----------------------|<-- fp + 8
//	  			|		X29 = fp'		|
//				|-----------------------|
//	  			|		X29 = fp'		|
//sp=sp'-32 -->	|-----------------------| <-- fp
//	  			|						|
//				|-----------------------|
//************************************************************************
// gcc -g Lab7_example5.s
// ./a.out
// Petros Panayi
// You have entered: Petros Panayi
//************************************************************************
//References:
//http://www.cplusplus.com/reference/cstdio/fopen/
//http://www.cplusplus.com/reference/cstdio/fscanf/
//http://www.cplusplus.com/reference/cstdio/fprintf/
//http://www.cplusplus.com/reference/cstdio/fclose/
//http://www.cplusplus.com/reference/cstdio/feof/
//http://www.cplusplus.com/reference/cstdio/fgets/
//http://www.cplusplus.com/reference/cstdio/stdin/
//************************************************************************

.data
output_str: 		.string "You have entered: %s"

	.text
	.global	main

main:
	add sp, sp, -256			//	Allocate space for the String in main's stack'
	stp	x29, x30, [sp, -16]!
	add	x29, sp, 0
	 			
	adr	x0, stdin				// Get the Pointer to the stdio
	ldr	x2, [x0]				// X0 contains the memeory address where the 
								// the strio pointer is stored. So read it from memory
	add x0, x29, 16				// Pointer to an array of chars where the string read is copied. 
	mov w1, 256					// The max number of characters to read
	bl fgets					// Call fgets
	add x1, x29, 16				// Get the pointer to the pointer to the String
	adr x0, output_str
	bl printf

	
	ldp	x29, x30, [sp], 16
	add sp, sp, 256				// Release the Local Table Space
	ret
